'From Smalltalk/X, Version:5.2.8 on 16-01-2008 at 01:34:52'                     !

"{ Package: 'SpreadSheet:all' }"

Object subclass:#AbstractTable
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!AbstractTable methodsFor:'accessing'!

cellAtRow:rowIndex column:colIndex 
    "return cell at given address"
    
    ^ self subclassResponsibility
!

cellAtRow:rowIndex column:colIndex put:object 
    "set cell at given address"
    
    ^ self subclassResponsibility
!

columnAt:colIndex 
    "returns array containing whole column with given index, nils where some cells not defined"
    
    ^ self subclassResponsibility
!

columnAt:colIndex put:array 
    "set given array as column with given index (rewrites current)"
    
    ^ self subclassResponsibility
!

data
    "returns data collection (itself), for future compatibility"
    
    ^ self
!

emptyCellAtRow:rowIndex column:colIndex 
    "deletes content of cell at given address"
    
    ^ self subclassResponsibility
!

emptyColumnAt:colIndex 
    "empties whole column with given index"
    
    ^ self subclassResponsibility
!

emptyRowAt:rowIndex 
    "empties whole row with given index"
    
    ^ self subclassResponsibility
!

rowAt:rowIndex 
    "returns array containing whole row with given index"
    
    ^ self subclassResponsibility
!

rowAt:rowIndex put:array 
    "set given array as row with given index (rewrites current)"
    
    ^ self subclassResponsibility
! !

!AbstractTable methodsFor:'iteration'!

columnsDo:block 
    "runs given block with all columns giving actual columns as a parameter"
    
    ^ self subclassResponsibility.
!

do:block 
    "runs given block with all cells (row by row) giving actual cell as a parameter"
    
    ^ self subclassResponsibility.
!

rowsDo:block 
    "runs given block with all rows giving actual row as a parameter"
    
    ^ self subclassResponsibility.
! !

!AbstractTable methodsFor:'modifying'!

delete:number columnsAt:colIndex 
    "delete number of columns at position given by colIndex (move ascending columns to the left) "
    
    ^ self subclassResponsibility.
!

delete:number rowsAt:rowIndex 
    "delete number of rows at position given by rowIndex (move ascending rows up)"
    
    ^ self subclassResponsibility.
!

insert:number emptyColumnsAt:colIndex 
    "inserts number of empty columnts at position given by colIndex"
    
    ^ self subclassResponsibility.
!

insert:number emptyRowsAt:rowIndex 
    "inserts number of empty rows at position given by rowIndex"
    
    ^ self subclassResponsibility.
!

insertColumn:anArray at:colIndex 
    "inserts anArray as a column at colIndex (moves remaining columns to the right"
    
    ^ self subclassResponsibility
!

insertRow:anArray at:rowIndex 
    "inserts anArray as a row at rowIndex (moves remaining rows to the bottom"
    
    ^ self subclassResponsibility
! !

!AbstractTable methodsFor:'querying'!

columnsCount
    "returns number of columns"
    
    ^ self subclassResponsibility
!

rowsCount
    "returns number of rows"
    
    ^ self subclassResponsibility
! !

