'From Smalltalk/X, Version:5.2.8 on 16-01-2008 at 01:34:53'                     !

"{ Package: 'SpreadSheet:all' }"

Object subclass:#CellReference
	instanceVariableNames:'sheet row col'
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!CellReference class methodsFor:'instance creation'!

newAtRow:rowIndex column:colIndex atSheet:aSheet 
      |tmp|
      tmp:= self new.
      tmp setReferenceRow:rowIndex column:colIndex atSheet:aSheet .
      ^ tmp.
! !

!CellReference methodsFor:'accessing'!

asString
        " e.g. : '<sheet name>'.C1 "
        ^ '''', sheet name, '''.',(col asAlphabet),(row asString).
!

value
    "strictly, CellReference cannot be in the cell directly, so no checkup needed,
    but who knows... Rather put it into the CellExpression object"
    self checkRecursion.
    ^self getCell value.
! !

!CellReference methodsFor:'listening'!

notifyColumnsFrom:colIndex reindexedBy:aNumber 
    "receives message about reindexing columns in spreadsheet"
    (colIndex <= col) ifTrue: [col := (col + aNumber)].
!

notifyRowsFrom:rowIndex reindexedBy:aNumber 
    "receives message about reindexing rows in spreadsheet"
    (rowIndex <= row) ifTrue: [row := (row + aNumber)].
! !

!CellReference methodsFor:'modifying'!

setReferenceRow:rowIndex column:colIndex atSheet:aSheet 
    "sets current reference "
    
    ((aSheet isNil not and:[ rowIndex isNumber ]) and:[ colIndex isNumber ]) ifTrue:[
        "do when good params are set only"
        (sheet == aSheet) ifFalse:[
            "if there was different sheet before"
            sheet ifNotNil:[ sheet unregisterReindexListener:self ].
            aSheet registerReindexListener: self.
        ].
        sheet := aSheet.
        row := rowIndex.
        col := colIndex.
    ].
! !

!CellReference methodsFor:'private'!

getCell
    ((sheet isNil or:[ row isNil ]) or:[ col isNil ]) ifTrue:[
        ^ CellUndefined new.
    ].

    ^ (sheet cellAtRow:row column:col).
! !

!CellReference methodsFor:'recursion-detection'!

checkRecursion
   "sends message deeper"
   self getCell checkRecursionAgainst: self.
!

checkRecursionAgainst: anObject
   "sends message deeper"
   (anObject == self) ifTrue: [^ RecursiveDefinitionError raise.].

   self getCell checkRecursionAgainst: anObject.
! !

