'From Smalltalk/X, Version:5.2.8 on 16-01-2008 at 01:34:53'                     !

"{ Package: 'SpreadSheet:all' }"

ExprOperator subclass:#ExprBinOperator
	instanceVariableNames:'lnode rnode'
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!ExprBinOperator class methodsFor:'creation'!

with: leftOperand with: rightOperand
        | newExpr |
        newExpr := self new.
        newExpr lnode: leftOperand; rnode: rightOperand.
        ^ newExpr.
! !

!ExprBinOperator methodsFor:'accessing'!

lnode
        ^ lnode.
!

rnode
        ^rnode.
!

stringRepr
        (self exprPriority < lnode exprPriority) ifTrue: [
                " left node is in parentheses "
                ((self exprPriority > rnode exprPriority) and: [rnode isUnaryOperator not]) ifTrue: [
                        " right node is not in parentheses "
                        ^ '(',(lnode asString),')', (self stringSymbol),
                        (rnode asString).
                ] ifFalse: [
                        " right node is in parentheses "
                        ^ '(',(lnode asString),')', (self stringSymbol),
                        '(',(rnode asString),')'.
                ]
        ] ifFalse: [
                " left node is not parentheses "
                ((self exprPriority > rnode exprPriority) and: [rnode isUnaryOperator not]) ifTrue: [
                        " right node is not in parentheses "
                        ^ (lnode asString),(self stringSymbol),
                        (rnode asString).
                ] ifFalse: [
                        " right node is in parentheses "
                        ^ (lnode asString),(self stringSymbol),
                        '(',(rnode asString),')'.
                ]
        ]
!

stringSymbol
        ^ self subclassResponsibility.
! !

!ExprBinOperator methodsFor:'creation'!

lnode: aNode
        lnode := aNode.
!

rnode: aNode
        rnode := aNode.
! !

!ExprBinOperator methodsFor:'recursion-detection'!

checkRecursionAgainst: anObject
   "sends message deeper"
   lnode checkRecursionAgainst: anObject.
   rnode checkRecursionAgainst: anObject.
! !

